// ======================================================================== 
// 文 件 名：数据缓存类     
// 功能描述：缓存一些请求次数比较多的数据                
// 作    者：suhao            
// 创建时间：2016-10-11
// 版    本：
// ------------------------------------------------------------------------
// 历史更新纪录
// ------------------------------------------------------------------------
// 版    本：           修改时间：           修改人：          
// 修改内容：
// ------------------------------------------------------------------------
// Copyright (C) 2016   北京荣大科技有限公司
// ======================================================================== 
var cache = {
		/**
		 * 缓存用户信息的Map
		 */
		cache_UserInfos : new HashMap(),

		/**
		 * 缓存项目组信息的Map
		 */
		cache_ProjItems : new HashMap(),

		/**
		 * 缓存项目信息的Map
		 */
		cache_Projects : new HashMap(),
		
		/**
		 * 缓存项目权限信息的Map
		 */
		cache_ProjItemPerms : new HashMap(),

		/**
		 * 缓存项目权限信息的Map
		 */
		cache_ProjPerms : new HashMap(),

		/**
		 * 缓存项目组中对文件权限信息的Map
		 */
		cache_filePerms : new HashMap(),

		/**
		 * 缓存服务人员列表的Map
		 */
		 cache_ServiceStaff : new HashMap(),
		 	 
		 /**
		  * 将缓存到得项目组信息，放入缓存中
		  * @param key pi_id
		  * @param value
		  */
		 setCacheProjItem : function(key,value){
			 this.cache_ProjItems.put(key,value);
		 },
		 
		 /**
		  * 根据项目组id在缓存中获取项目组的详细信息，
		  * 如果在缓存中没有查询到项目组的信息，
		  * 通过网络请求，获取项目组信息
		  * @param key
		  */
		 getCacheProjItem : function(key){
			try {
			 	var projItem=this.cache_ProjItems.get(key);
				if(projItem==null || projItem == undefined){
					var map = new HashMap();
			 		map.put("pi_id", key);
			 		map.put("user_id", main_loginUserId);
			 		var projItemObj = doCallAjax.doSynchronousAjax("ProjectItemModel", "getProjItem", map);
			 		var projItemJson = JSON.parse(projItemObj);
			 		if(projItemJson.status=="200"){
			 			projItem = projItemJson;
//				 		projItem=JSON.parse(projItem);
				 		this.setCacheProjItem(key,projItemJson);
			 		}
				}
				return projItem;
			} catch(e) {
				console.log("erorr_[cache]_[getCacheProjItem]:" + e);
			}
		 },

		 /**
		  * 将缓存到得项目信息，放入缓存中
		  * @param key pi_id+_+proj_id
		  * @param value
		  */
		 setCacheProject : function(key,value){
			 this.cache_Projects.put(key,value);
		 },
		 /**
		  * 根据pi_id+_+proj_id在缓存中获取项目的详细信息，
		  * 如果在缓存中没有查询到项目的信息，
		  * 通过网络请求，获取项目信息
		  * @param key pi_id+_+proj_id
		  */
		 getCacheProject : function(key){
			try {
				 var project=this.cache_Projects.get(key);
				 if(project==null || project == undefined){
					 	var keyStr=key.split("_");
					 	var pi_id=keyStr[0];
					 	var proj_id=keyStr[1];
						var map = new HashMap();
				 		map.put("pi_id", pi_id);   
				 		map.put("proj_id", proj_id);
				 		var projectObj = doCallAjax.doSynchronousAjax("ProjectModel", "getProjectInfoByPjId", map);
				 		var projectJson = JSON.parse(projectObj);
				 		if(projectJson.status=="200"){
				 			project = projectJson.datas;
					 		this.setCacheProject(key,project);
				 		}
					}
			 	return project;
			} catch(e) {
				console.log("erorr_[cache]_[getUserInfo]:" + e);
			}
		 },


		 /**
		  * 将缓存到得用户信息，放入缓存中
		  * @param key user_id
		  * @param value
		  */
		 setUserInfo : function(key,value){
			 this.cache_UserInfos.put(key,value);
		 },

		 /**
		  * 根据用户id在缓存中获取用户的详细信息，
		  * 如果在缓存中没有查询到用户信息，
		  * 通过网络请求，获取用户信息
		  * @param key user_id
		  */
		 getUserInfo : function(key){
			try {
			    var userJsonObj = this.cache_UserInfos.get(key);
			    if (userJsonObj == null || userJsonObj == undefined) {
			        var map = new HashMap();
			        map.put("user_id", key);
			        var userObj = doCallAjax.doSynchronousAjax("UserModel", "getUserInfo", map);
			         var userdata =userObj.datas;
					userObj = JSON.stringify(userObj);
			        var userJsonDataObj = JSON.parse(userObj);
			        if (userJsonDataObj.status == "200") {
			            userJsonObj = userJsonDataObj.datas;
			            this.setUserInfo(key, userJsonObj);
			        }
			    }
			    return userJsonObj;
			} catch(e) {
				    console.log("erorr_[cache]_[getUserInfo]:" + e);
			}
		 },
		 /**
		  * 根据用户id从网络中获取用户信息
		  * 这个必须从网络取，不从缓存取，因为有可能缓存的不是最新的
		  * 
		  * @param key user_id
		  */
		 getUserInfoByNet : function(key){
			try {
		        var map = new HashMap();
		        map.put("user_id", key);
		        var userObj = doCallAjax.doSynchronousAjax("UserModel", "getUserInfo", map);
				userObj = JSON.stringify(userObj);
		        var userJsonDataObj = JSON.parse(userObj);
		        if (userJsonDataObj.status == "200") {
		            userJsonObj = userJsonDataObj.datas;
		            this.setUserInfo(key, userJsonObj);
		        }
			    return userJsonObj;
			} catch(e) {
				    console.log("erorr_[cache]_[getUserInfoByNet]:" + e);
			}
		 },

		 /**
		  * 将缓存到得项目组权限信息，放入缓存中
		  * @param key pi_id
		  * @param value
		  */
		 setCacheProjItemPerms : function(key,value){
		 	this.cache_ProjItemPerms.put(key,value);
		 },
		 /**
		  * 根据pi_id在缓存中获取项目组权限的详细信息，
		  * 如果在缓存中没有查询到项目组权限的信息，
		  * 通过网络请求，获取项目组权限信息
		  * @param key pi_id
		  */
		 getCacheProjItemPerms : function(key){
			try {
				var pitemperms=this.cache_ProjItemPerms.get(key);
				if(pitemperms == null || pitemperms == undefined){
					var map = new HashMap();
					map.put("pi_id", key);
			 		map.put("user_id", main_loginUserId);
			 		var itempermObj = doCallAjax.doSynchronousAjax("ProjectItemModel", "getPermsFromPItemByUser", map);
			 		var pitempermsObj = JSON.parse(itempermObj);
			 		if(pitempermsObj.status=="200"){
			 			pitemperms = pitempermsObj.datas;
				 		this.setCacheProjItemPerms(key,pitemperms);
			 		}
				}
			 	return pitemperms;
			} catch(e) {
				console.log("erorr_[cache]_[getCacheProjItemPerms]:" + e);
			}
		 },

		 /**
		  * 将缓存到得项目权限信息，放入缓存中
		  * @param key pi_id_proj_id
		  * @param value
		  */
		 setCacheProjPerms : function(key,value){
		 	this.cache_ProjPerms.put(key,value);
		 },
		 /**
		  * 根据pi_id+_+proj_id在缓存中获取项目权限的详细信息，
		  * 如果在缓存中没有查询到项目权限的信息，
		  * 通过网络请求，获取项目权限信息
		  * @param key pi_id+_+proj_id
		  */
		 getCacheProjPerms : function(key){
			 try {
				 var projectPerms=this.cache_ProjPerms.get(key);
				 if(projectPerms==null || projectPerms == undefined){
					 	var keyStr=key.split("_");
					 	var pi_id=keyStr[0];
					 	var proj_id=keyStr[1];
						var map = new HashMap();
				 		map.put("pi_id", pi_id);
				 		map.put("proj_id", proj_id);
				 		map.put("user_id", main_loginUserId);
				 		var projectObj = doCallAjax.doSynchronousAjax("ProjectModel", "getMyProjPermission", map);
				 		var projectJson = JSON.parse(projectObj);
				 		if(projectJson.status=="200"){
				 			projectPerms = projectJson.datas;
					 		this.setCacheProjPerms(key,projectPerms);
				 		}
					}
			 	return projectPerms;
			} catch(e) {
				console.log("erorr_[cache]_[getCacheProjItemPerms]:" + e);
			}
		 },

		 /**
		  * 将缓存到得项目组所有对文件的权限信息，放入缓存中
		  * @param key pi_id
		  * @param value 存入的数据中包含多条数据，是一个集合
		  */
		 setCacheFilePerms : function(key,value){
			 this.cache_filePerms.put(key,value);
		 },
		 /**
		  * 根据pi_id在缓存中获取项目组所有对文件的权限的详细信息，
		  * 如果在缓存中没有查询到项目组所有对文件的权限的信息，
		  * 通过网络请求，获取项目组所有对文件的权限信息
		  * @param key pi_id
		  * 取到的数据中包含多条数据，是一个集合
		  */
		 getCacheFilePerms : function(key){
			 try {
				 var filePerms=this.cache_filePerms.get(key);
				 if(filePerms==null || filePerms == undefined){
						var map = new HashMap();
				 		map.put("pi_id", key);
				 		map.put("user_id", main_loginUserId);
				 		var permObj = doCallAjax.doSynchronousAjax("FilePermsModel", "getUserAllPerms", map);

				 		var permJson = JSON.parse(permObj);
				 		if(permJson.status=="200"){
				 			filePerms = permJson.datas;
					 		this.setCacheFilePerms(key,filePerms);
				 		}
					}
			 	return filePerms;
			} catch(e) {
				console.log("erorr_[cache]_[getCacheProjItemPerms]:" + e);
			}
		 },


		 /**
		  * 将缓存到的服务人员列表信息，放入缓存中
		  * @param key user_id
		  * @param value 
		  * 
		  */
		 setCacheServiceStaff : function(key,value){
			 this.cache_ServiceStaff.put(key,value);
		 },

		 /**
		  * 根据user_id在缓存中获取服务人员的详细信息，
		  * @param key user_id
		  * 
		  */
		 getCacheServiceStaff : function(key){
		 	return this.cache_ServiceStaff.get(key);
		 }

};
//websocket 对象提供在线离线功能
/*var websocket = null;
$(function () {
	$("#Mzi1_neb").hide();
	initCache();
	initUserInfo();
	initWebsocket(websocket,false);
	sendMessage();
});*/
//初始化缓存
function initCache(){
	var map = new HashMap();
	map.put("modelmethod", "getReleteUserInfos,getPermInfoFromPItemByUser,getCanSeeProjItem,getProjByUserId,getMyProjPermission,getUserAllPerms,getServerList");
	map.put("user_id",main_loginUserId);
	map.put("dataCompress", "1");
	doCallAjax.doAsynchronousAjax("ClientCacheModel","getClientCacheData",map,success_loadCache);
    function success_loadCache(cacheData){
    	try{
	        var zipedData=eval('(' + cacheData + ')');
	        var status=zipedData.status;
	        if(status!="200"){
//	        	alert("数据查询异常，请稍后重试！！");
	        	return;
	        }
	        var Obj =zipedData.datas;
	        Obj = window.parent.base64decode(Obj);
	        var pako = window.parent.pako;
	        Obj = pako.inflate( Obj, { to: 'string' } ); 
	        Obj=eval('(' + Obj + ')');
	    	var projItemList=Obj.datas_ProjItemList;
	    	if(projItemList!="" && projItemList.length>0 && projItemList!=undefined){
	    		for(var i in projItemList){
		    		var pi_id=projItemList[i].pi_id;
		    		//将获取的项目组信息，缓存到页面中
		    		cache.setCacheProjItem(pi_id,projItemList[i]);
		    		//解析项目组的权限
		    		var pi_perm_str="datas_"+pi_id+"_ProjItemPerms";
		    		var projItemPrerm=Obj[pi_perm_str];
		    		cache.setCacheProjItemPerms(pi_id,projItemPrerm); //缓存项目组的权限
		    		//解析项目组中的项目列表
		    		var pi_projList_str="datas_"+pi_id+"_ProjList";
		    		var pi_projList=Obj[pi_projList_str];
		    		for(var j in pi_projList){
		    			var proj_id=pi_projList[j].proj_id;
		    			//将获取的项目信息，缓存到页面中
		    			cache.setCacheProject(pi_id+"_"+proj_id,pi_projList[j]);
		    			var permKey="datas_" + pi_id + proj_id + "_MyProjPerm";
		    			var projPerm=Obj[permKey];
		    			if(projPerm!=null && projPerm!="" && projPerm!=undefined){
		    				//将获取的项目的权限信息，缓存到页面中
		    				cache.setCacheProjPerms(pi_id+"_"+proj_id,projPerm);
		    			}
		    		}
		    		//将获取的项目组对所有文件权的限信息，缓存到页面中
			    	var filePermKey="datas_" + pi_id + "_FilePerms";
			    	var filePerms=Obj[filePermKey];
		    		if(filePerms!=null && filePerms!="" && filePerms!="undefined"){
		    			cache.setCacheFilePerms(pi_id,filePerms);
		    		}
		    	}
	    	}
	    
	    	//将获取的用户信息，缓存到页面中
	    	var userInfos=Obj.datas_UsersInfo;
	    	if(userInfos!="" && userInfos.length>0 && userInfos!=undefined){
	    		for(var k in userInfos){
		    		var user_id=userInfos[k].user_id;
		    		cache.setUserInfo(user_id,userInfos[k]); 
		    	}
	    	}
	    	
	    	//将获取的制作员列表信息，缓存到页面中
	    	var ServiceStaff=Obj.datas_StaffList;
	    	ServiceStaff=eval('(' + ServiceStaff + ')');
	    	if(ServiceStaff!="" && ServiceStaff.length>0 && ServiceStaff!=undefined){
	    		for(var i in ServiceStaff){
		    		var nodeId=ServiceStaff[i].nodeId;
		    		var nodeName=ServiceStaff[i].nodeName;
		    		var staffList=ServiceStaff[i].staffList;
		    		for(var k in staffList){
		    			var serviceInfo=staffList[k];
		    			var user_id=serviceInfo.acct_id;
		    			serviceInfo["nodeId"]=nodeId;
		    			serviceInfo["nodeName"]=nodeName;
		    			cache.setCacheServiceStaff(user_id,serviceInfo); 
		    		}
		    	}
	    	}
    	}catch(e){
    		console.log("Error_[cache.js]_[初始化页面时，获取页面缓存出错]:"+e);
    	}
    }
}

//初始化个人信息
var staff_status = ""; //服务人员状态
var login_username = "";//当前用户名
function initUserInfo(){
	try{
    	//处理个人信息
    	var userInfo = cache.getUserInfo(main_loginUserId);
    	//获取当前用户是否为服务人员
    	var staff = cache.getCacheServiceStaff(main_loginUserId);
    	var userName = userInfo.name;
    	login_username = userInfo.name;
//    	var user_id = userInfo.user_id;
    	var userImg = userInfo.user_img;
    	//个人头像
    	if(userImg != undefined && userImg != "" && userImg != null){
    		$("#aMger_id").attr('src',window.parent.ossImageUrl + userImg+"?x-oss-process=image/resize,m_mfit,h_60,w_60");
    	}else{
    		if(userInfo.sex==2){
    			$("#aMger_id").attr('src',"img/ol_default_woman.png");
    		}else{
    			$("#aMger_id").attr('src',"img/ol_default_man.png");
    		}
    	}
    	$("#Mzi1_userinfo").attr("name",userName);
    	$("#Mzi1_userinfo").attr("user_id",main_loginUserId);
    	$("#Mzi1_userinfo").html(userName);
    	//服务人员状态处理
    	if(staff != null && staff != undefined){
    		staff_status = '1'; //服务人员
    		$("#extract_id").show();
    		var status = staff.offline_status;
    		if(status == "0"){
    			$("#Mzi1_neb").find("i").removeClass("busy");
    		}
    		if(status == "1"){
    			$("#Mzi1_neb").find("i").addClass("busy");
    		}
    		$("#Mzi1_neb").show();
    		changeProdStaffStatus(status, "on");
    	}else{
    		$("#extract_id").hide();
    	}
	}catch(e){
		console.log("初始化个人信息"+e);
	}
	
	
}


/** 
*获取一个文件对应的权限
*pi_id 项目组id
*proj_id 项目id
*file_id 要判断的文件id
*user_id 当前用户id
*parentids 完整父路径id
*/
function getFilePerms(pi_id,proj_id,file_id,user_id,parentids) {
    try
    {
        //1、判断这个用户是否为项目组管理员
        if (isPIManager(pi_id, user_id)) {
            return window.parent.FilePermsType.AllPerms;
        }
        //2、判断这个用户是否为项目管理员
        if (isProjManager(pi_id, proj_id , user_id)){
            return window.parent.FilePermsType.AllPerms;
        }

        //3、获取项目组下的文件权限集合
        var filePerms = cache.getCacheFilePerms(pi_id);
        if (filePerms != null) {
            for(var i in filePerms){
            	var filePerm = filePerms[i];
            	if(file_id==filePerm.file_id){
            		return filePerm.perms_type;
            	}
            	
            	// 需要找上级的权限了。
                // 如果parentids不为空，则判断父级的权限
                if (parentids != null && parentids.length > 0)
                {
                    var parentslist = parentids.split(',');
                    var parent_id = "";
                    for (var j in parentslist)
                    {
                        parent_id = parentslist[j];
                        if(parent_id==filePerm.file_id){
                        	return filePerm.perms_type;
                        }
                    }
                }
            }
        }
        
        //4、判断这个用户的角色
        var roleperms = cache.getCacheProjPerms(pi_id+"_"+proj_id);
        if(roleperms!=null){
        	var perm_type = roleperms.perm_type;
            var perjson = JSON.parse(window.parent.parsePerms(perm_type));
            // 如果是编辑者
            var fomanage = perjson.prfomanage;
            if (fomanage == "true")
            {
                return window.parent.FilePermsType.AllPerms;
            }
            //如果是查看者
            var foview = perjson.prfoview;
            if (foview =="true")
            {
                return window.parent.FilePermsType.ViewPerms;
            }
        }       
        return   window.parent.FilePermsType.NOPerms;
    }catch (e) {
        return window.parent.FilePermsType.NOPerms;
    }
}

/**
* 判断用户是否为项目组创建者
* 
*/
function isPIManager(pi_id,user_id){
    try{
        var projitem = cache.getCacheProjItem(pi_id);
        if (projitem!=null){
            if (user_id==projitem.user_id){
                return true;
            }
        }
        return false;
    }catch (e) {
        return false;
    }
}

/**
* 判断用户是否为项目创建者
* 
*/
function isProjManager(pi_id,proj_id,user_id)
{
    try
    {
    	var proj = cache.getCacheProject(pi_id+"_"+proj_id);
    	if (proj!=null){
    		if (user_id==proj.user_id){
    			return true;
    		}
    	}
    	return false;
    } catch (e){
    	return false;
    }
};

/**
 * ele_class 
 * 命名规定:
 * html_ID(指定ID) 普通标签：更新指定样式的html信息
 * img_ID (指定ID)  img标签：更新指定样式的src信息
 * @param ele_class
 * @param info
 */
function updateInfoByClass(ele_class,info){
	if(info == null || info == undefined || info == ""){
		console.log("info参数无效");
		return false;
	};
	if(ele_class == null || ele_class == undefined || ele_class == ""){
		console.log("ele_class参数无效");
		return false;
	};
	
	//更新主窗体指定样式的html信息
	$("."+ele_class).each(function(index,obj){
		doWork(obj,ele_class,info);
	});
	
	//更新主窗体指定样式的html信息
	if(window.parent._main_fileWin != null){
		var $main_fileWin = $(window.parent._main_fileWin.document);
		$main_fileWin.find("."+ele_class).each(function(index,obj){
			doWork(obj,ele_class,info);
		});
	};
	
	//更新主页消息指定样式的html信息
	if(window.parent.main_msgWin != null){
		var $main_msgWin = $(window.parent.main_msgWin.document);
		$main_msgWin.find("."+ele_class).each(function(index,obj){
			doWork(obj,ele_class,info);
		});
	};
	
	
	//更新回收站信息指定样式的html信息
	if(window.parent.main_recycleWin != null){
		var $main_recycleWin = $(window.parent.main_recycleWin.document);
		$main_recycleWin.find("."+ele_class).each(function(index,obj){
			doWork(obj,ele_class,info);
		});
	};
	
	//更新项目组信息指定样式的html信息
	if(window.parent._main_projItemWin != null){
		var $_main_projItemWin = $(window.parent._main_projItemWin.document);
		$_main_projItemWin.find("."+ele_class).each(function(index,obj){
			doWork(obj,ele_class,info);
		});
	};
	
	function doWork(obj,ele_class,info){
		if(ele_class.indexOf("img_") > -1){
			$(obj).attr("src",info);
		}else{
			$(obj).html(info);
		}
	};
}
//定时器 30秒运行一次 加载一次缓存
//var timename=setInterval(initCache,30000);

/**
 * 根据pi_id删除缓存中的项目组权限与对应的项目组中项目的权限信息，
 * @param pi_id
 * 
 */
function  delProjItemPerms(pi_id){
	cache.cache_ProjItemPerms.remove(pi_id);
	for(var key in cache.cache_ProjPerms){
		if(key.indexOf(pi_id)>-1){
			cache.cache_ProjPerms.remove(key);
		}
	}
}
/**
 * 
 * @param websocket
 * @param reconnect 断开重连（ture/false）
 * @returns {___websocket1}
 */
function initWebsocket(websocket,reconnect){
	websocket = null;
	var wsServer = window.parent.ON_OFF_LINE_SERVER;
	//创建websocket对象
	if(reconnect){
		//断开重连 创建WebSocket对象
		websocket = new ReconnectingWebSocket(wsServer); 
	}else{
		//初始化创建WebSocket对象
		websocket = new WebSocket(wsServer);  
	}
	//websocket.send("hello");//向服务器发送消息 ,在此处发送会抛出异常Failed to execute 'send' on 'WebSocket': Still in CONNECTING state.  
	//alert(websocket.readyState);//查看websocket当前状态  
	websocket.onopen = function (evt) {
	    //已经建立连接 
		console.log("已经建立连接");  
	};  
	websocket.onclose = function (evt) {
	    //已经关闭连接  
		console.log("已经关闭连接");  
	};  
	websocket.onmessage = function (evt) {
	    //收到服务器消息，使用evt.data提取  
	    evt.stopPropagation();
	    evt.preventDefault();
	    var binaryString = base64decode(evt.data);
	    var pako = window.pako;
	    var restored = pako.inflate( binaryString, { to: 'string' } ); // ่งฃ
	    //将字符串转换为json对象
	    online.list = eval("(" + restored + ")");
	    //更新所有区域显示
	    online.update();
	};  
	websocket.onerror = function (evt) {
	    //产生异常  
		console.log("连接异常");   
	};
	return websocket;
};

	//在线离线数据通信
	function sendMessage(){
		setInterval(function(){
			//断网重连
			if(websocket == null || websocket.readyState === 3){
				websocket = initWebsocket(websocket,true);
	        };
			//通过回掉函数 完成消息发生
			waitForSocketConnection(websocket, function(){
	        	 websocket.send(main_loginUserId);
		    });
		}, 5000);
	};

	//通过回掉函数实现 js轮询
	function waitForSocketConnection(websocket, callback){
	    setTimeout(
	        function () {
	        	//检测websocket是否完成连接
	            if (websocket.readyState === 1) {
	                if(callback != null){
	                    //通过回掉实现消息发生
	                	callback();
	                }
	                return;
	            } else {
	                //等待连接
	                waitForSocketConnection(websocket, callback);
	            }

	        }, 1000);
	};
