var doCallAjax = {
		/**
		 * 方法说明
		 * @method doCallAjax
		 * @for 所属类名
		 * @param {参数类型} modelName 模块名称  method  模块方法 
		 *                args 参数  success 成功后仅有返回结果的回掉
		 *                complete 执行结束函数回掉 error 执行失败函数回掉
		 * @return {返回值类型} 返回值说明
		 */
		doCallAjax : function(flag, modelName, method, args, success, complete, error) {
		    //参数处理
			var argsTemp = args;
			var result ='';
		    args = dealArgs(modelName, method, args,flag);
		    
		    var isAsync =true;
		    var timeout = 30000;//超时时间：30秒【作用：对断网无效，仅对请求等待有效】
		    if(flag== "0"||flag== "4"){//同步
		    	isAsync =false;
		    }
		    if(flag== "1"||flag== "5"){//异步
		    	isAsync =true;
		    }
		    if(flag== "2"){//无超时  同步
		    	isAsync =false;
		    	timeout=0;
		    }
		    if(flag== "3"){//无超时   异步
		    	isAsync =true;
		    	timeout=0;
		    }
		    
		    $.ajax({
		        type: "POST",
		        //async Boolean(默认: true) 默认设置下，所有请求均为异步请求。如果需要发送同步请求，请将此选项设置为 false。注意，同步请求将锁住浏览器，用户其它操作必须等待请求完成才可以执行。
		       async: isAsync,
               url: base_url_path,
               data: args,
               dataType:'json',
               timeout: timeout,
		        //请求异常回掉操作
		        error: function(XMLHttpRequest, textStatus, errorThrown) {
//		            console.log("2--执行ajax出现异常 :【readyState" + XMLHttpRequest.readyState + "】");
		            var jsonObj = JSON.parse("{}");
		            if (XMLHttpRequest.readyState == "0" ) {
		            	jsonObj["status"]="301";
	            		jsonObj["datas"]="";
	            		jsonObj["msg"]="网络异常,请重试";
	            		jsonObj["code"]="network error";
		            	if (success != null && success!="" && success!="undefined") {
			                success(JSON.stringify(jsonObj),argsTemp);
			            }
		            }
		            result=JSON.stringify(jsonObj);
		        },

		        //请求成功后的回掉操作         
		        success: function(myData) {
		        	//判断是否token过期 如果过期直接跳转登录界面（与需求确认不考虑正在上传文件 直接返回登录界面）
					var dataObj;
					try{
						dataObj=eval("("+myData+")");
					}catch(e){
					dataObj = myData;
					}
		        	
		        	var status = dataObj.status;
//		            console.log("2--执行ajax成功并返回数据");
		            if (success != null && success!="" && success!="undefined") {
		                success( JSON.stringify(dataObj),argsTemp);
		            }
		            result = dataObj;
		        },

		        //请求完成后的操作        
		        complete: function(XMLHttpRequest, textStatus) {
		            if (complete != null && complete!="" && complete!="undefined") {
//		            	console.log("3--此次请求结束：" + "【readyState" + XMLHttpRequest.readyState + "】" + "【responseText" + XMLHttpRequest.responseText + "】" + "【status" + XMLHttpRequest.status + "】" + "【textStatus" + XMLHttpRequest.textStatus + "】");
		                complete(XMLHttpRequest, textStatus,argsTemp);
		            }
		        }
		    });

		    //参数处理
		    function dealArgs(modelName, method, args,flag) {
//		        console.log("1--开始处理传入参数");

		        /** 第三方程序调用的接口的模块参数名称  **/
		        var ParaModelName = "rd_dms_name";
		        /** 第三方程序调用的接口的模块方法参数名称  **/
		        var ParaModelMethod = "rd_dms_method"; 
		        /** 第三方程序调用的接口的Token参数名称  **/
		        var ParaToken = "rd_dms_token";
		        var jsonObj = args.getEntry();
		        var paraStr = JSON.stringify(jsonObj);
		        var para = JSON.parse(paraStr);
		        para[ParaModelName] = modelName;
		        para[ParaModelMethod] = method;
//		        if(flag=="4"||flag=="5"){
//		        	para[ParaToken] =callAjax_token_id;
//		        	para["login_type"] = login_type;
//		        }else{
		            para[ParaToken] = rd_dms_token;
			        para["login_type"] = "android";
//		        }

		        return para;
		    }
		    if(!isAsync){
		    	return result;
		    }
		},
		
		/**t
		 * 0 设置同步方法
		 * 1 设置异步方法
		 * 2 设置无超时时间方法  同步
		 * 3 设置无超时时间方法  异步
		 * */
		/** 同步ajax*/
		doSynchronousAjax :function (modelName, method, args, success, complete, error) {
		    return this.doCallAjax("0", modelName, method, args, success, complete, error);
		},
		/** 异步ajax*/
		doAsynchronousAjax:function (modelName, method, args, success, complete, error) {
		    this.doCallAjax("1", modelName, method, args, success, complete, error);
		},
		
		/** 无超时时间ajax  同步方法*/
		doNoTimeOutSyncAjax:function (modelName, method, args, success, complete, error) {
			this.doCallAjax("2", modelName, method, args, success, complete, error);
		},
		/** 无超时时间ajax   异步方法*/
		doNoTimeOutAsyncAjax:function (modelName, method, args, success, complete, error) {
			this.doCallAjax("3", modelName, method, args, success, complete, error);
		},
		/** 携带自定义token  同步*/
		doSynAjaxForToken:function (modelName, method, args, success, complete, error) {
			return	this.doCallAjax("4", modelName, method, args, success, complete, error);
		},
		/** 携带自定义token  异步*/
		doAsynAjaxForToken:function (modelName, method, args, success, complete, error) {
			this.doCallAjax("5", modelName, method, args, success, complete, error);
		}
}


/*--start test-------自己当前业务方法的回掉*/
/**
	 * 方法说明
	 * @method getMesgInfo 测试方法
	 * @for 所属类名
	 * @param {参数类型} 
	 * @return {返回值类型} 返回值说明
	 */
function getMesgInfo() {
    var map = new HashMap();
    map.put("user_id", "10835");
    map.put("pi_id", "123917");
    map.put("dateFlag", "");
    map.put("com_fresh_id", "");
    map.put("fresh_id", "");
    map.put("com_pageId", "227737");
    map.put("pageId", "");
    map.put("pageindex", "1");
    map.put("comPageindex", "1");
    map.put("status", "");
    doCallAjax.doAsynchronousAjax("MsgInfoModel", "getHomeMsgList", map, mySuccess, myComplete, myError);
}

/*--end test-------自己当前业务方法的回掉*/